//sass-lint:disable nesting-depth, no-important
// blog general

/* Note: the page template for blog categories isn't found in the blog directory, it's found in the site root. */

.blog-category-nav {
  overflow-x: scroll;
  -webkit-overflow-scrolling: touch;

  ul {
    display: flex;
    padding: 10px;
    margin: 0;
    margin-bottom: 20px;

    li {
      list-style: none;
      padding: 16px 12px;
    }

    a {
      font-weight: 600;
      padding: 10px;
      color: inherit;
      text-transform: capitalize;
      white-space: nowrap;

      &:hover {
        opacity: .8;
        text-decoration: none;
        color: inherit;
      }

    }

  }

}

.blog .callout,
.gitlab-trial {
  clear: both;
  text-align: center;
  padding: 40px 0 100px;
  font-size: 18px;
  color: $blog-color-text;
  background-color: $color-white;

  h1,
  h2,
  h3,
  h4 {
    margin: 20px 0 14px;
    font-weight: 600;
  }

  a {

    &.contact {
      color: $blog-color-purple;
    }

  }

  h3 {
    line-height: 1;
    padding: 0 25px;
  }

  h4 {
    margin: 15px 40px;
  }

  @media only screen and (max-width : 768px) {
    padding: 35px 0 45px;

    h3 {
      font-size: 32px;
      line-height: 1;
      padding: 0 25px;
    }
  }
}

.blog {
  font-size: 16px;
  line-height: 1.58;
  color: $blog-color-text;

  .callout,
  .gitlab-trial {
    background-color: $body-bg;
    padding: 50px 0 70px;

    p {
      margin: 20px auto;
      max-width: 780px;
    }

  }

  h1,
  h2,
  h3,
  h4 {
    margin: 20px 0 14px;
  }

  .wrapper {
    max-width: 1050px;
    margin: 0 auto;
    clear: both;
  }

  .sticky-banner {
    height: inherit;
    padding: 6px 0 4px;

    .sticky-banner-content {
      max-width: 1050px;
      padding: 0 75px;
      margin: 0 auto;
    }

    .sticky-banner-text {
      display: inline-block;
      float: left;
    }

    .action {
      padding-top: 11px;
      display: inline-block;
      float: right;
    }
  }

  .tag-list {
    margin-bottom: $spacing-unit-sm !important; // override previous deep selector
    font-size: 0; // For better control of space between tags

    .tag {
      display: inline-block;
      padding: 4px 8px;
      border-radius: 3px;
      background-color: $color-gray-extra-light;
      font-size: 14px;

      &:not(:first-of-type) {
        margin-left: 10px;
      }

      a {
        color: $text-color-light !important; // override previous deep selector

        &:hover {
          color: $blog-color-purple !important;
        }
      }
    }
  }

  &.list {
    .section {
      margin: 20px 40px 0;
    }

    .articles {
      display: flex;
      flex-wrap: wrap;
    }

    .article {
      flex: 0 0 auto;
      background: $color-white;
      box-shadow: 0 2px 4px $color-transparent-alt;
      margin: 0 10px 5px;
      width: calc(50% - 20px);
      border-radius: 3px;

      a {
        color: $blog-color-purple;

        &:hover {
          color: $link-color;
          text-decoration: none;
        }
      }
    }

    &.list-category-page,
    &.list-tag-page {
      .article {
        margin-bottom: 20px;
      }
    }

    .article-information {
      padding: 25px;
    }

    .author-gitlab {
      i {
        color: $color-gray;
        text-decoration: none;

        &:hover {
          color: $color-secondary;
          text-decoration: none;
        }
      }
    }

    .author-twitter {
      i {
        color: $color-gray;
        text-decoration: none;

        &:hover {
          color: $link-color;
          text-decoration: none;
        }
      }
    }

    .cover {
      text-decoration: none;
      display: block;
      width: 100%;
      height: 220px;
      background-repeat: no-repeat;
      background-position: 50%;
      background-size: cover;
      position: relative;
      border-radius: 2px 2px 0 0;

      h3 {
        margin: 0;
        padding: 20px;
        text-align: center;
        color: $blog-color-heading;
        vertical-align: middle;
        position: relative;
        top: 50%;
        transform: translateY(-50%);
      }
    }

    .overlay {
      background: linear-gradient(123deg, $blog-color-image-from, $blog-color-image-to);
      display: block;
      height: 100%;
      border-radius: 2px 2px 0 0;
    }

    .author {
      float: left;
    }

    .date {
      color: $blog-color-date;
      float: right;
    }

    .summary {
      clear: both;
      margin-top: 46px;
      font-size: 18px;
      height: 85px;
      text-overflow: ellipsis;
      overflow: hidden;
    }

    .more,
    .browse {
      font-weight: 600;
      border-radius: 4px;
      border: 1px solid $blog-color-mk-border;
      cursor: pointer;
      display: inline-block;
      padding: 7px 12px 6px;
      text-align: center;
      vertical-align: middle;
      margin-top: 10px;
      color: $blog-color-purple;
      background-color: $color-white;
    }

    .browse {
      margin: 0 10px;
    }

    .more:hover,
    .browse:hover {
      background-color: $blog-color-purple;
      border: 1px solid $blog-color-purple;
      color: $color-white !important;
    }

    @media only screen and (max-width : 768px) {
      .section {
        margin: 0 0 10px;
      }

      .panel {
        margin: 0 0 15px;
      }

      .articles {
        flex-direction: column;
      }

      .article {
        width: calc(100% - 20px);
        margin: 10px;
      }

      .article-information {
        padding: 10px;
      }
    }
  }

  &.article {
    .wrapper {
      padding: 50px 75px;
    }

    .header {
      box-shadow: none;
      padding: 100px 75px 50px;
      color: $blog-color-heading;

      .btn {
        margin-top: 15px;
      }
    }

    .body {
      background-color: $color-white;
      padding-bottom: 55px;

      p:not(.panel-heading) {
        margin: 20px 0 40px 0;
      }

      ul {
        margin-bottom: 0;
      }

      ol {
        margin-bottom: 32px;
      }
    }

    .content {
      margin-bottom: 40px;
      font-size: 19px;

      blockquote {
        font-size: 19px;
      }
    }

    .social {
      width: 152px;
      margin: 0 auto;
    }

    .signup {
      padding: 20px;
      background: $color-gray-extra-light-alt;
      position: relative;
    }

    .comments {
      margin-top: 20px;
      background-color: $color-white;
      box-shadow: 0 3px 3px $blog-color-border-shadow;
      padding-bottom: 90px;
    }

    .body a:not(.btn):not(.twitter-block-link),
    .newsletter a {
      color: $blog-color-purple;
    }

    .cover {
      display: flex;
      flex-direction: column;
      background-size: cover;
      background-position: center center;
      background-repeat: no-repeat;
      position: relative;
      min-height: 400px;

      @media all and (max-width: $screen-md-min) {
        min-height: 0;
      }
    }

    .overlay {
      background: linear-gradient(to bottom, $blog-color-image-from, $blog-color-image-to);
      width: 100%;
      margin-top: auto;
      margin-bottom: 0;
    }

    h1 {
      font-size: 34px;
      margin: 15px 0 10px;
      clear: both;
    }

    .author,
    .date {
      font-size: 17px;
      font-weight: 600;
      display: inline-block;

      a {
        color: $blog-color-heading;
        text-decoration: none;

        &:hover {
          text-decoration: none;
          color: $blog-color-purple;
        }
      }
    }

    .author-gitlab {
      i {
        color: $color-white;

        &:hover {
          color: $color-secondary;
          text-decoration: none;
        }
      }
    }

    .author-twitter {
      i {
        color: $color-white;

        &:hover {
          color: $link-color;
          text-decoration: none;
        }
      }
    }

    .description {
      font-size: 20px;
      margin-bottom: 0;
    }

    .alert {
      font-size: 18px;
    }

    // sass-lint:disable no-important
    .twitter-tweet {
      margin: 0 auto 32px !important;
    }
    // sass-lint:enable no-important

    @media only screen and (max-width : 768px) {
      .wrapper {
        padding: 10px;
      }

      .signup {
        padding: 0;
        border-bottom: 0;
      }

      .header {
        padding: 40px 10px;
      }

      .content {
        font-size: 18px;
      }
    }
  }

  &.archives {
    padding-top: 20px;
    font-size: 18px;

    .wrapper {
      max-width: 925px;
      box-shadow: 0 3px 3px $blog-color-border-shadow;
      margin-bottom: 90px;
      font-size: 16px;
    }

    .section {
      padding: 75px;
      background-color: $color-white;
    }

    .tag-index-list {
      columns: 220px;
      column-gap: 40px;
    }

    li {
      border-bottom: 1px solid $color-gray-medium;
      margin: 0 0 5px;
      padding: 0 0 5px;
      overflow: hidden;
      break-inside: avoid;
    }

    a {
      color: $blog-color-purple;
    }

    a:visited {
      color: $blueish-gray;
    }

    time {
      float: right;
      color: $blog-color-date;
    }
  }

  .pager {
    margin-top: 15px;

    .fa {
      position: relative;
      top: 1px;

      &.fa-chevron-left {
        margin-right: 5px;
      }

      &.fa-chevron-right {
        margin-left: 5px;
      }
    }
  }
}



// Category Back Link

.category-back-link {
  padding: 0 0 20px;

  @media only screen and (max-width: $screen-xs-max) {
    padding-top: 20px;
    padding-bottom: 10px;
  }

  a {
    color: $color-gray !important;
  }
}



// blog category nav
.navbar.blog-category-navbar {
  margin: 20px 15px 32px;

  @media only screen and (min-width : 992px) {
    margin: 30px 0 35px;
  }

  .navbar-toggle {
    width: 100%;
    border-color: $color-gray-medium;
    background-color: $color-white;
    box-sizing: border-box;
    margin: 0;
    color: $color-gray;
    text-align: left;
    padding: 9px 12px 9px 20px;

    .fa {
      color: $color-gray-medium;
      float: right;
      top: 5px;
      position: relative;
      font-size: 12px;
    }
  }

  .navbar-collapse {
    @media only screen and (max-width: $screen-sm-max) {
      position: absolute;
      width: 100%;
      top: 100%;
      z-index: 5;
    }

    @media only screen and (min-width : $screen-md-min) {
      padding: 0 10px;
    }
  }

  .nav.navbar-nav {

    @media only screen and (max-width : 991px) {
      margin-top: 3px;
      background-color: $color-white;
      border: 1px solid $color-gray-medium;
      border-radius: 4px;
      padding: 7px 0 10px;
    }

    a {
      color: $blog-color-category-nav;

      @media only screen and (max-width : 991px) {
        padding: 10px 20px;
      }

      @media only screen and (min-width : 992px) {
        font-weight: 600;
        border-bottom: 4px solid transparent;
        padding: 10px 12px;
      }

      &:hover,
      &:active {
        color: $color-primary;
        border-bottom-color: $color-primary;

        @media only screen and (min-width : 992px) {
          background: none;
        }
      }
    }

    li {
      @media only screen and (min-width : 992px) {
        margin-right: 35px;
      }

      &:last-child {
        margin-right: 0;
      }

      &.active {
        a {
          color: $color-primary;

          @media only screen and (max-width : 991px) {
            font-weight: bold;
          }

          @media only screen and (min-width : 992px) {
            border-bottom-color: $color-primary;
          }
        }
      }
    }
  }
}

.related h2.u-margin-bottom-md {
  margin-bottom: 30px;
  @media (min-width: 992px) {
    margin-bottom: 60px;
  }
}

// newsletter & social panel
.panel.panel-newsletter-signup {
  background: none;
  box-shadow: none !important;
  border: 0;
  margin: 0 10px;

  @media only screen and (max-width : 991px) {
    text-align: center;
  }

  @media only screen and (max-width: $screen-md-min) {
    padding: 20px 0;
  }

  .row {
    @media only screen and (max-width : 991px) {
      margin: 0 5px;
    }
  }

  .col-follow-us {
    @media only screen and (max-width : 991px) {
      margin-bottom: 15px;
    }

    @media only screen and (min-width : 992px) {
      margin-top: 3px;
    }

    span {
      display: inline-block;
      position: relative;
      top: -2px;
      margin: 0 1px 0 0;
    }
  }

  .social-link {
    display: inline-block;
    margin: 0 7px;
  }

  .fa {
    font-size: 24px;
    color: $color-primary;

    &:hover {
      color: darken($color-primary, 5%);
    }
  }
}


// newsletter

.newsletter {
  display: flex;
  flex-wrap: wrap;
  align-items: center;

  @media only screen and (max-width: $screen-sm-max) {
    justify-content: center;
    flex-wrap: wrap;
  }

  .newsletter-form {
    margin: auto;
    margin-right: 0;
    width: 74%;

    .mrktoForm {
      margin-top: 10px !important;
    }

    // sass-lint:disable class-name-format
    .mktoFormRow {
      margin-bottom: 0 !important;
      order: 1000;
    }

    .mktoFormRow:nth-child(2) {
      order: 1;

      @media (max-width: $screen-md) {
        width: 100% !important;
        margin-top: 10px !important;
      }

    }

    .mktoButtonRow {
      order: 2;

      .mktoButton {
        padding: 10px !important;
      }

      @media (max-width: $screen-md-min) {
        width: 100% !important;
        margin-top: 10px !important;
      }

    }
    // sass-lint:enable class-name-format

    .confirm-message p {
      margin-bottom: 0;
    }

    @media only screen and (max-width: $screen-sm-max) {
      width: 100%;
      margin: 20px 0;
    }

  }

  .sbmc {
    width: 100px;
  }

}

.rss-btn {
  margin-right: 8px;
}

.newsletter-form div {
  display: inline;
}

// sass-lint:disable class-name-format, no-important

.mktoFieldDescriptor.mktoFormCol {
  margin-bottom: 0 !important;
}

.newsletter-form .mktoForm {
  display: flex;
  width: auto !important;
  flex-wrap: wrap;
  margin: auto;
  margin-top: 10px;

  .mktoFormRow:nth-child(2) {
    order: 1;
    margin-right: 6px !important;

    @media (max-width: $screen-md-min) {
      margin-right: 0 !important;
    }

  }

  .mktoFieldDescriptor {
    width: 100% !important;
  }

  .mktoLogicalField {
    width: 100% !important;
    margin: 10px 0;
    font-size: 11px;
    display: inline-block;

    @media only screen and (max-width: $screen-md-min) {
      font-size: 12px;
    }

  }

  @media only screen and (max-width : 480px) {
    padding: 0 !important;
  }

  @media only screen and (max-width : $screen-sm-max) {
    width: 310px !important;
    max-width: 100% !important;
    padding: 0 !important;
  }
}

.newsletter-form .mktoFieldWrap {
  float: none !important;
}

.newsletter-form .mktoField {
  background-color: $color-white;
  background-image: none;
  border-radius: $border-radius-large !important;
  box-shadow: none !important;
  color: $blog-color-text;
  display: block;
  font-size: 14px !important;
  padding: 8px 12px !important;
  width: 100%;
  height: auto !important;

  @media (max-width: $screen-md-min) {
    width: 100% !important;
  }

  &[type=checkbox] {
    width: auto;
    display: inline;
    margin-right: 5px;

    @media (max-width: $screen-md-min) {
      width: auto !important;
    }
  }

}

.newsletter-form .mktoButtonWrap {
  margin: 0 !important;
}

.newsletter-form .mktoButton {
  background-color: $color-primary;
  background-image: none;
  border-radius: $border-radius-large;
  border: none !important;
  cursor: pointer;
  display: inline-block;
  font-size: 14px;
  margin-bottom: 0;
  height: 100%;
  text-align: center;
  user-select: none;
  vertical-align: middle;
  white-space: nowrap;
  color: $color-white !important;
  font-weight: bold;
  width: 110px;

  &:hover {
    background-color: darken($color-primary, 5%) !important;
  }

  @media (max-width: $screen-md-min) {
    margin-left: 0 !important;
    width: 100% !important;
  }

  @media (max-width: $screen-sm-min) {
    padding: 10px;
  }

}

.newsletter-form .mktoButton:hover {
  background-color: $blog-color-overlay-border;
  border-color: $blog-color-mk-border;
  color: $blog-color-text;
}

.newsletter-form .mktoAsterix,
.newsletter-form .mktoGutter,
.newsletter-form .mktoLabel,
.newsletter-form .mktoOffset {
  display: none;
  width: 0;
}

.newsletter-form .mktoFormCol {
  margin: 0;
}

.newsletter-form .mktoClear,
.newsletter-form .mktoFormRow {
  clear: none;
  margin-bottom: 0 !important;
}

// sass-lint:enable no-important, class-name-format


// legacy stuff that a lot of the other pages depend on specifically the handbook

.blog-entry,
.md-page {
  margin-right: auto;
  margin-left: auto;
  max-width: 900px;
  font-size: 16px;
  word-wrap: break-word;

  .author {
    display: inline;
    font-weight: 600;

    a {
      font-weight: 600;
      line-height: normal;
    }
  }

  .date {
    color: $blog-color-text;
    font-weight: 300;
    font-size: 16px;
    margin-left: 4px;
    margin-top: 10px;
    padding-bottom: 10px;
  }

  .panel-heading {
    a {
      font-size: inherit;
    }
  }

  li {
    color: $blog-color-text;
    margin-top: .5em;
  }

  .image-title h1 a {
    color: $color-white;
    font-weight: 600;
    font-size: 40px;
  }

  h1 {
    margin-bottom: 0;

    &.image-title {
      font-size: 30px;
      color: $color-white;
      font-weight: 600;
      line-height: 40px;
    }

    a {
      font-size: 30px;
      color: $blog-color-text;
      font-weight: 600;
      line-height: 41px;
    }
  }

  h1,
  h2,
  h3,
  h4,
  h5 {
    color: $blog-color-text;
    font-weight: 600;
  }

  p {
    color: $blog-color-text;
    line-height: 1.5;

    &.note {
      font-size: 14px;
      font-style: italic;
      color: $blog-color-text;
    }
  }

  blockquote {
    p {
      font-size: 16px;
      font-style: normal;
      color: $blog-color-text;
    }
  }

  .table-responsive {
    margin-bottom: 0;
    border: 0;
  }
}

.blog-entry {
  h3 {
    font-size: 30px;
    color: $blog-color-text;
    font-weight: 200;
    padding-top: 12px;
  }
}

.image-title .color-bg {
  position: relative;
  display: block;
  padding: 200px 40px;
  margin-top: 0;
  color: $color-white;
  font-weight: 600;
  font-size: 55px;
  text-align: center;
  height: 500px;
  background: linear-gradient(-225deg, $blog-color-legacy-image-from 0%, $blog-color-legacy-image-to, 100%);

  h1 {
    color: $color-white;
  }
}

pre {
  border-radius: 0;
}

// newsletter signup call to action
.panel-newsletter-cta {
  border: 1px solid $border-color;
  background: $body-bg;
  text-align: center;
  color: $color-primary;

  @media (min-width: $screen-xs) {
    width: 302px;
    float: right;
    margin: 0 0 40px 40px;
  }

  .panel-header {
    padding: 20px 16px 0;

    .newsletter-sub-preamble,
    .newsletter-preamble {
      font-size: 16px;
      font-weight: 700;
    }

    .newsletter-preamble {
      margin-top: 10px;
    }
  }

  .panel-body {
    padding: 0;
  }

  .newsletter-sub-preamble {
    font-size: 16px;
    font-weight: 600;
    margin: 0 0 18px;
  }

  .newsletter-form {
    width: 100%;

    .mktoForm {
      width: 100% !important;
    }

    .mktoFieldWrap {
      margin-right: 0 !important;
    }

    [type=email] {
      width: 100% !important;
      float: none;
      margin-bottom: 10px;
      border: 0 !important;
      box-shadow: none !important;
      font-size: 16px !important;
      padding: 8px 12px !important;
    }

    .mktoErrorMsg {
      color: #FFF;
    }
  }

  .mktoForm .mktoFormRow {
    width: 100%;
    display: block;
    text-align: center;
    margin-bottom: 0 !important;

    .mktoFieldDescriptor {
      width: calc(100% - 40px) !important;
      display: inline-block;
      margin: 0 auto;
      float: none;
    }
  }

  .mktoButtonRow {
    display: block;
    margin: 22px;
    margin-top: 0;
    border-radius: $border-radius-large;
    width: 100%;
    order: 2;

    .mktoButtonWrap {
      display: block;
    }
  }

  .mktoButtonRow:hover {
    background-color: $blog-color-overlay-border;
  }

  .mktoButton {
    background-color: $color-primary;
    // background-image: linear-gradient(to right, $purple-section-gradient-from, $purple-section-gradient-to 100%);
    color: $color-white;
    border: 0;
    border-radius: $border-radius-large;
    display: block;
    width: 100%;
    font-size: 16px;
    font-weight: 600;
    padding: 14px !important;

    &:hover {
      color: $color-white;
    }
  }

  .success-image {
    width: 120px;
    margin: 20px 0 46px;
  }

  &.newsletter-cta-a {
    svg path {
      fill: $purple-section-gradient-to;
    }
  }

  &.newsletter-cta-b {
    background: $color-orange;
    // background-image: linear-gradient(180deg, $orange-section-gradient-from, $orange-section-gradient-to 100%);
    border: 0;
    color: $color-white;
  }

}

// Unfilted category
.categories-intro-copy {
  margin-bottom: 40px;
}

//sass-lint:enable-all
